#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int max1 = 0, v1;
bool go = true;
vector<vector<int>> g;
vector<int> d, d_res, d_res1, path;
vector<bool> used, used1;

void dfs(int v, int h) {
    used[v] = true;
    d[v] = h;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, h + 1);
        }
    }
}

void dfs_path(int v, int h) {
    used1[v] = true;
    if (go) {
        path.push_back(v);
    }
    if (h == max1) {
        go = false;
    }
    for (auto to : g[v]) {
        if (!used1[to]) {
            dfs_path(to, h + 1);
        }
    }
    if (go) {
        path.pop_back();
    }
}
void dfs_res(int v, int h) {
    used1[v] = true;
    if (v == v1) {
        d_res[v] = 1;
        h = 1;
    } else {
        d_res[v] = h;
    }
    for (auto to : g[v]) {
        if (!used1[to]) {
            dfs_res(to, h + 1);
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    g.resize(n);
    d.resize(n, 0);
    d_res.resize(n, 0);
    d_res1.resize(n, 0);
    used.resize(n, false);
    used1.resize(n, false);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if (k >= 2) {
        if (n == 2) {
            cout << 1 << '\n';
            return 0;
        }
        cout << min((n + k) / (k + 1), n - 2);
        return 0;
    }
    dfs(0, 0);
    for (int i = 0; i < n; i++) {
        max1 = max(max1, d[i]);
    }
    if (max1 == 3) {
        cout << 1 << '\n';
        return 0;
    }
    used1.assign(n, false);
    dfs_path(0, 0);
    used1.assign(n, false);
    int cnt = 1;
    for (int i = 1; i < (int) path.size(); i++) {
        if (cnt == max1 / 2 + max1 % 2) {
            v1 = path[i];
        }
        cnt++;
    }
    dfs_res(0, 0);
    int max2 = 0;
    for (int i = 0; i < n; i++) {
        max2 = max(max2, d_res[i]);
    }
    cout << max2;
    return 0;
}
