#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<vector<int>> g;
vector<int> d;
vector<bool> used;

void dfs(int v, int h) {
    used[v] = true;
    d[v] = h;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, h + 1);
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    g.resize(n);
    d.resize(n, 0);
    used.resize(n, false);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, 0);
    int max1 = 0, max2 = 0;
    for (int i = 0; i < n; i++) {
        max1 = max(max1, d[i]);
    }
    max2 = max1 / 2 + max1 % 2;
    for (int i = 0; i < n; i++) {
        if (max1 != d[i]) {
            max2 = max(max2, d[i]);
        }
    }
    cout << max2;
    return 0;
}
