#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    vector<bool> prime(1000001, true);
    for (ll i = 2; i <= 1000000; i++) {
        if (prime[i]) {
            if (i * i <= 1000000) {
                for (ll j = i * i; j <= 1e6; j += i) {
                    prime[j] = false;
                }
            }
        }
    }
    vector<ll> color(1000001, 1);
    color[1] = 2;
    for (ll i = 2; i <= 1000000; i++) {
        if (prime[i]) {
            if (i * i <= 1000000) {
                for (ll j = i * i; j <= 1000000; j += i) {
                    if (prime[j / i] || color[j / i] == 1) {
                        color[j] = 2;
                    }
                }
            }
        }
    }
    ll n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        ll num;
        cin >> num;
        cout << color[num] << ' ';
    }
    return 0;
}
