#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll bin_pow(ll num, ll pow) {
    if (pow == 0) {
        return 1;
    }
    if (pow % 2 == 0) {
        ll temp = bin_pow(num, pow / 2);
        return temp * temp;
    } else {
        return bin_pow(num, pow - 1) * num;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<int> a(n), t(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> t[i];
        t[i]--;
    }
    ll l = -1, r = 4 * 1e9;
    while (r - l > 1) {
        ll mid = (r + l) / 2;
        ll cnt = 0;
        for (int i = 0; i < n; i++) {
            if (mid > a[i] + t[i]) {
                if (mid - a[i] - t[i] >= 64) {
                    cnt += 1e12;
                } else {
                    cnt += bin_pow(2, mid - a[i] - t[i]);
                }
            } else if (mid >= a[i]) {
                cnt++;
            }
        }
        if (cnt >= m) {
            r = mid;
        } else {
            l = mid;
        }
    }
    ll cnt = 0;
    for (int i = 0; i < n; i++) {
        if (r > a[i] + t[i]) {
            cnt += bin_pow(2, r - a[i] - t[i]);
        } else if (r >= a[i]) {
            cnt++;
        }
    }
    if (cnt == m) {
        cout << r;
    } else {
        cout << -1;
    }
    return 0;
}
